﻿using eShopOnContainers.Core.Services.RequestProvider;
using System;
using System.Threading.Tasks;
using eShopOnContainers.Core.Models.User;

namespace eShopOnContainers.Core.Services.User
{
    public class UserService : IUserService
    {
        private readonly IRequestProvider _requestProvider;

        public UserService(IRequestProvider requestProvider)
        {
            _requestProvider = requestProvider;
        }

        public async Task<UserInfo> GetUserInfoAsync(string authToken)
        {
            try
            {
                UriBuilder builder = new UriBuilder(GlobalSetting.Instance.UserInfoEndpoint);

                string uri = builder.ToString();

                var userInfo =
                    await _requestProvider.GetAsync<UserInfo>(uri, authToken);

                return userInfo;
            }
            catch
            {
                return new UserInfo();
            }
        }
    }
}